jQuery(document).ready(function(){
    vap_isMobile = false;
    API_READY = false;
    loadYTAPI();
});
    //load YT api
    function loadYTAPI(){
      var tag = document.createElement('script');
      tag.src = "//www.youtube.com/iframe_api";
      var firstScriptTag = document.getElementsByTagName('script')[0];
      firstScriptTag.parentNode.insertBefore(tag, firstScriptTag);
    }

function onYouTubeIframeAPIReady() {
    API_READY = true;
}
    

//PREVIEW
function VideoPreview(){
    var previewContainer;
    var vidEngine;
    var videoContainer;
    var vContainerModel;
    var firstTime=true;
    var _self = this;
    //init
    this.init = function(json){        
        if(!API_READY){
            alert('Error, please upgrade your browser!');
            return;
        }        
        if(firstTime){
            firstTime = false;
            jQuery(window).resize(function(){
                resize();
                EventBus.dispatchEvent(new Event(Event.SK_WINDOW_RESIZE, ""));                
            });
        }        
        
        
        var mjson_data = new MainData();        
        if(json==""){
            alert('Error, please build a banner first!');          
            return;
        }else{                  
            var temp_data = jQuery.parseJSON(json);
            mjson_data = jQuery.extend(new MainData(), temp_data);
            mjson_data.isEmpty = false;
            vContainerModel = jQuery.extend(new VideoContainerModel(), mjson_data.getVideoContainerModel());
        }
        
        
        //video template 
        var videoTemplate = IFrameTemplates.getInstance().getVideoITemplate(vContainerModel.getVideoID(), vContainerModel.getVideoWidth(), vContainerModel.getVideoHeight(), vContainerModel.getIFrameID());       
        
        //console.log(videoTemplate);
        
        //preview container
        previewContainer = jQuery('<div id="previewContainer"></div>');
        previewContainer.appendTo(jQuery('body'));
        
        //video container
        videoContainer = jQuery('<div class="sk_videoContainer"></div>');
        videoContainer.appendTo(previewContainer);
        videoContainer.css('width', '100%');
        videoContainer.css('max-width', vContainerModel.getVideoWidth()+'px');
        videoContainer.css('max-height', vContainerModel.getVideoHeight()+'px');
        
        //video content
        var videoContent = jQuery('<div class="sk_videoContent"></div>');
        videoContent.appendTo(videoContainer);
        jQuery(videoTemplate).appendTo(videoContent);        
        
        //position
        videoContainer.css('position', 'absolute');        
        
        //add close
        addCloseAbsolute();
        
        resize();
           
        //engine
        vidEngine = new SKVideoEngine();
        vidEngine.init(json, videoContainer);           
    }
    
    var closePrevBTN;
    function addCloseAbsolute(){
        closePrevBTN = jQuery('<a id="closePrevBTN" class="button-primary" style="position: absolute;">Close preview</a>');
        closePrevBTN.appendTo(previewContainer);
        closePrevBTN.click(function(e){
            e.preventDefault();
            _self.gcc();
        });        
    }
    
    function addClose(){
        //close preview
        var closePrevUI = jQuery('<div id="sk_closePreview"></div>');
        var closePrevBTN = jQuery('<a id="closePrevBTN" class="button-primary">Close preview</a>');
        closePrevBTN.appendTo(closePrevUI);
        closePrevUI.appendTo(jQuery('body'));
        closePrevBTN.click(function(e){
            e.preventDefault();
            _self.gcc();
        });        
    }
    
    //resize
    function resize(){
        try{
            videoContainer.css('left', (jQuery(window).width()/2-vContainerModel.getVideoWidth()/2)+'px');
            videoContainer.css('top', (jQuery(window).height()/2-vContainerModel.getVideoHeight()/2)+'px');
            closePrevBTN.css('left', (jQuery(window).width()/2-closePrevBTN.width()/2)+'px');
            closePrevBTN.css('top', (jQuery(window).height()/2-(vContainerModel.getVideoHeight()/2+45))+'px');            
        }catch(e){}
    }
    
    this.gcc = function(){
        try{
           vidEngine.gcc();                       
           previewContainer.empty();
           previewContainer.remove();
           jQuery('#sk_closePreview').remove();
           vidEngine = null;            
        }catch(e){}
    }
}
VideoPreview.getInstance=function(){
    if(VideoPreview.instance==null){
        VideoPreview.instance = new VideoPreview();
    }
    return VideoPreview.instance;
}

