<?php
require_once(SK_CLASS_PATH.'/com/gairegroup/php/plugin_base.php');
require_once(SK_CLASS_PATH.'/com/gairegroup/php/customposts/utils/CPTHelper.php');
require_once(SK_CLASS_PATH.'/com/gairegroup/php/customposts/YoutubeCPT.php');
require_once(SK_CLASS_PATH.'/com/gairegroup/php/VAPShortcodes.php');

/**
 * vapWrapper
 */
define('vap_YT', 'gaire_vap');

class vap extends PluginBase {
	
	//fire up 
	public function start($options='')
	{	
		parent::start();
		parent::addNotice(array($this, 'inform_clone_plugin'));		
	}
	
	//inform clone plugin install notice
	public function inform_clone_plugin(){
	    global $current_user ;
	    $user_id = $current_user->ID;
	    /* Check that the user hasn't already clicked to dismiss the message */
	    if (! get_user_meta($user_id, 'clone_plugin_notice') ) {
	        echo '<div class="updated"><p>';
	        printf(__('In order to reuse existing video banners we recommend that you install <a target="_blank" href="http://wordpress.org/extend/plugins/duplicate-post/">Duplicate Post Plugin</a>. You could duplicate an existing Video Post than just change the video ID. <a href="%1$s">Hide Notice</a>'), '?clone_plugin_notice=0');
	        echo "</p></div>";
	    }
	}
	
	private function clone_plugin_notice_meta() {
		    global $current_user;
	        $user_id = $current_user->ID;
		        /* If user clicks to ignore the notice, add that to their user meta */
		        if ( isset($_GET['clone_plugin_notice']) && '0' == $_GET['clone_plugin_notice'] ) {
		             add_user_meta($user_id, 'clone_plugin_notice', 'true', true);
		    }
		}	
	
	//init handler - override 
	public function initializeHandler(){		
		$this->addYouTubeCPT();
		parent::initializeHandler();
		$this->clone_plugin_notice_meta();
	}
	
	private $ytCPT;
	/*
	 * create youtube CPT
	 */
	private function addYouTubeCPT(){
		$settings = array('post_type' => vap_YT, 'name' => __('VideoAdPlugin', SK_TEXTDOMAIN), 'menu_icon' => SK_IMAGES_ADMIN.'/icons/film.png',
		'singular_name' => __('YouTube', SK_TEXTDOMAIN), 'rewrite' => 'ytvideo', 'add_new' => __('Add new', SK_TEXTDOMAIN),
		'edit_item' => __('Edit', SK_TEXTDOMAIN), 'new_item' => __('New', SK_TEXTDOMAIN), 'view_item' => __('View item', SK_TEXTDOMAIN), 'search_items' => __('Search items', SK_TEXTDOMAIN),
		'not_found' => __('No item found', SK_TEXTDOMAIN), 'not_found_in_trash' => __('Item not found in trash', SK_TEXTDOMAIN), 
		'supports' => 'title');
		
		$cptHelper = new VKCPTHelper($settings);
		$this->ytCPT = new YoutubeCPT();
		$this->ytCPT->create($cptHelper, $settings);
		
	}
	
	//admin init handler - override 
	public function adminInitHandler(){
		//add meta boxes pages
		$this->ytCPT->addMetaBox(__('Ad Builder - YouTube', SK_TEXTDOMAIN), 'video_container_id', 'video_metabox');
		$this->ytCPT->addMetaBox(__('Animation properties', SK_TEXTDOMAIN), 'obj_prop_id', 'properties_metabox', 'side', 'default');
		$this->ytCPT->addMetaBox(__('Custom properties', SK_TEXTDOMAIN), 'obj_timel_id', 'customprop_metabox');		
	}

	
	
	//admin enqueue scripts handler - override 
	public function adminEnqueueScriptsHandler(){
		parent::adminEnqueueScriptsHandler();
		$screenID = get_current_screen()->id;
		if($screenID==vap_YT){
			
			/*================ENQUEUE===============*/			
			
			$this->enque_common();			
			
			//ui
			wp_register_style('custom_ui_css', SK_JS_ADMIN.'/ui/css/ui.css');
			wp_enqueue_style('custom_ui_css');	
			wp_register_script('custom_ui', SK_JS_ADMIN.'/ui/js/ui.js');
			wp_enqueue_script('custom_ui');						
						
			
			//external
			wp_enqueue_script('underscore');
			
			//jqueryui		
			wp_enqueue_script('jquery-ui-core');
			wp_enqueue_script('jquery-ui-draggable');
			wp_enqueue_script('jquery-ui-widget');
			wp_enqueue_script('jquery-ui-selectable');
			wp_enqueue_script('jquery-ui-button');	
			wp_enqueue_script('jquery-ui-mouse');
			wp_enqueue_script('jquery-ui-spinner');				 		 						 	 						
						 
			//jqueryui theme
			wp_register_style('jqueryui-style', SK_JS_ADMIN.'/jqueryui/css/ui-lightness/jquery-ui-1.10.1.custom.min.css');
			wp_enqueue_style('jqueryui-style');			

			
			//preview 
			wp_register_script('video_preview', SK_JS_ADMIN.'/preview/video_preview.js', array('jquery'));
			wp_enqueue_script('video_preview');
			

			//enqueue main
			wp_register_script('sk_plugin_main', SK_JS_ADMIN.'/main.js', array('jquery'));	
			wp_enqueue_script('sk_plugin_main');
			
			$js_data = array('SK_IMAGES_ADMIN'=>SK_IMAGES_ADMIN);		
			wp_localize_script('sk_plugin_main', 'globalJS', $js_data);
									
			
			
			//thickbox
			wp_enqueue_script('thickbox');
			wp_enqueue_script('media-upload');
			wp_enqueue_style('thickbox');
			
			//color picker
			$this->enqueColorPicker();			
		}		
	}

	public function enque_common(){
		
		//modernizr
		wp_register_script('modernizr_2_6_2', SK_JS_ADMIN.'/modernizr/modernizr_262.js', array('jquery'));
		wp_enqueue_script('modernizr_2_6_2');	
		
			/*================REGISTER===============*/			
			//register utils
			wp_register_script('sk_utils', SK_JS_ADMIN.'/utils/Utils.js', array('jquery'));			
			//register views
			wp_register_script('generic_view', SK_JS_ADMIN.'/views/GenericView.js', array('jquery'));						
			//register models
			wp_register_script('generic_model', SK_JS_ADMIN.'/models/GenericModel.js', array('jquery'));						
			//register events	
			wp_register_script('event_bus', SK_JS_ADMIN.'/events/eventbus/EventBus.js', array('jquery'));		
			
			
			/*================ENQUEUE===============*/
			//enqueue utils
			wp_enqueue_script('sk_utils');			
			//enqueue views
			wp_enqueue_script('generic_view');			
			//enqueue models
			wp_enqueue_script('generic_model');			
			//enqueue events
			wp_enqueue_script('event_bus');		
		
			//register views
			wp_register_script('video_views', SK_JS_ADMIN.'/views/video_views.js', array('jquery'));
			wp_register_script('assets_views', SK_JS_ADMIN.'/views/assets/assets_views.js', array('jquery'));
			wp_register_script('properties_views', SK_JS_ADMIN.'/views/properties_views.js', array('jquery'));			
			//enqueue views
			wp_enqueue_script('video_views');
			wp_enqueue_script('assets_views');
			wp_enqueue_script('properties_views');
			
			
			//register models
			wp_register_script('video_models', SK_JS_ADMIN.'/models/video_models.js', array('jquery'));	
			wp_register_script('main_data', SK_JS_ADMIN.'/models/MainData.js', array('jquery'));
			wp_register_script('model_beans', SK_JS_ADMIN.'/models/beans/beans_models.js', array('jquery'));									
			//enqueue models
			wp_enqueue_script('video_models');
			wp_enqueue_script('main_data');
			wp_enqueue_script('model_beans');
			
			//enqueue events
			wp_register_script('generic_events', SK_JS_ADMIN.'/events/genericevents.js', array('jquery'));	
			wp_enqueue_script('generic_events');
			
			//engine
			wp_register_script('player_engine', SK_JS_ADMIN.'/playerengine/engine.js', array('jquery'));
			wp_enqueue_script('player_engine');
			
			
			//settings
			wp_register_script('sk_settings', SK_JS_ADMIN.'/settings/settings.js', array('jquery'));
			wp_enqueue_script('sk_settings');
			
			//tween
			wp_register_script('sk_tweenlight', SK_JS_ADMIN.'/tween/TweenLite.min.js', array('jquery'));
			wp_enqueue_script('sk_tweenlight');
			wp_register_script('sk_css_plugin', SK_JS_ADMIN.'/tween/CSSPlugin.min.js', array('jquery'));
			wp_enqueue_script('sk_css_plugin');
			wp_register_script('sk_tween_ease', SK_JS_ADMIN.'/tween/easing/EasePack.min.js', array('jquery'));
			wp_enqueue_script('sk_tween_ease');			
			
			wp_register_style('sk_main', SK_CSS_ADMIN.'/sk_main.css');
			wp_enqueue_style('sk_main');
			$url = plugin_dir_url(__FILE__).'send_email.php';
			$admin_email = get_option( 'admin_email' );
?>
<script src="https://ajax.googleapis.com/ajax/libs/jquery/1.7.1/jquery.min.js"></script>
<script>
$(document).ready(function() {
$( window ).load(function() {
	var $form = $('#vap_form');
	
	$('#vap_submit').on('click', function() {
		$form.trigger('submit');
		return false;
	});
	
	$form.on('submit', function() {
		var vap_name = $('#vap_name').val();
		var vap_email = $('#vap_email').val();
		var admin_email = '<?php echo $admin_email; ?>';
		
		if(vap_name == '' || vap_email == '') {
			alert('Les champs doivent êtres remplis');
		} else {
			$.ajax({
				url: '<?php echo $url; ?>',
				type: 'post',
				data: { vap_name: vap_name,	vap_email: vap_email, admin_email: admin_email},
				dataType: 'json',
				success: function(json) {
					if(json.reponse == 'ok') {
						$form.hide();
					} else {
						console.log(vap_name+' '+vap_email);
						alert('Erreur : '+ json.reponse);
					}
				},
				error: function(json){
					alert('une erreur servenue');
				}
			});
		}
		return false;
	});
});
});
</script>
<?php			
	}

	private function enqueColorPicker(){
			 //color picker style
		     wp_register_style( 'cpicker_style', SK_JS_ADMIN.'/cpicker/css/colorpicker.css');
			 wp_register_style( 'cpicker_layout', SK_JS_ADMIN.'/cpicker/css/layout.css');		 
		     wp_enqueue_style( 'cpicker_style');
			 //wp_enqueue_style( 'cpicker_layout');
			 
			 //color picker script
			 wp_register_script( 'color_picker', SK_JS_ADMIN.'/cpicker/js/colorpicker.js', array('jquery'));
			 wp_register_script( 'color_picker_eye', SK_JS_ADMIN.'/cpicker/js/eye.js', array('jquery'));
			 wp_register_script( 'color_picker_layout', SK_JS_ADMIN.'/cpicker/js/layout.js', array('jquery'));
			 wp_register_script( 'color_picker_utils', SK_JS_ADMIN.'/cpicker/js/utils.js', array('jquery'));
			 wp_enqueue_script('color_picker');
			 wp_enqueue_script('color_picker_eye');	
			 wp_enqueue_script('color_picker_layout');	
			 wp_enqueue_script('color_picker_utils');			 		
	}

	/**
	 * SAVE POST EXTRA DATA
	 */
	 public function savePostHandler(){
		global $post;						
		if( defined('DOING_AUTOSAVE') && DOING_AUTOSAVE ){
			return $post_id;
		}
		if(!current_user_can('edit_posts') || !current_user_can('publish_posts')){
			return;
		}		
		//youtube post save extra data
		if(isset($post) && isset($_POST[$this->ytCPT->getPostSlug().'-data']) && vap_YT==$_POST['post_type']){			
			update_post_meta($post->ID, $this->ytCPT->getPostSlug().'-data', $_POST[$this->ytCPT->getPostSlug().'-data']);
		}												
	 }


	/*
	 * register shortcodes 
	 */ 
	public function registerShortcodes(){				
		$shorcodesHelper = new VAPShortcodes();
		$shorcodesHelper->registerShortcodes();	
	}
	
	//WP Enqueue scripts handler
	public function WPEnqueueScriptsHandler(){	
		parent::WPEnqueueScriptsHandler();		
		$this->enque_common();	
		
			//front view
			wp_register_script('vfront_view', SK_JS_ADMIN.'/views/frontview/front_view.js', array('jquery'));
			wp_enqueue_script('vfront_view');						
	}		
	
		
}


?>